% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
%
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
%
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
%
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
function init
global systemValue
systemValue.ModelFileName = 'TwoWheelPendulum';
if exist(systemValue.ModelFileName) ~= 4
    % w肳ꂽt@C݂ȂA̓ft@CłȂꍇB
    systemValue.ModelFileName = bdroot;
end
execInit();
assignin('base', 'EnableLineTrace', 0);
assignin('base', 'EnableCP', 0);
assignin('base', 'EnableCS', 0);
assignin('base', 'ProgramMode', 0);
%
global defValue;
defValue.WheelBase      = 14;
defValue.WheelR         = 4.25;
defValue.GyroP          = 1.1;  %0.6055;
defValue.GyroI          = 0;
defValue.GyroD          = 0.07;  %0.0495;
defValue.WheelP         = 0.0145;
defValue.WheelI         = 0.0078;
defValue.WheelD         = 0.023;  %0.0192;
defValue.LightP         = 6*defValue.WheelR*pi/180;
defValue.LightI         = 0;
defValue.LightD         = 0.1;
defValue.CircleR        = 50;
defValue.CircleT        = 15;
defValue.LongSide       = 60;
defValue.ShortSide      = 40;
defValue.hok_t0         = 0.1;
defValue.hok_vfactor    = 0.5;
defValue.LongR          = 25;
defValue.ShortR         = 25;

assignin('base', 'GP', defValue.GyroP);
assignin('base', 'GI', defValue.GyroI);
assignin('base', 'GD', defValue.GyroD);
assignin('base', 'WP', defValue.WheelP);
assignin('base', 'WI', defValue.WheelI);
assignin('base', 'WD', defValue.WheelD);
assignin('base', 'LP', defValue.LightP);
assignin('base', 'LI', defValue.LightI);
assignin('base', 'LD', defValue.LightD);
assignin('base', 'CircleR', defValue.CircleR);           % 2016/6/22 %
assignin('base', 'CircleT', defValue.CircleT);           % 2016/6/22 %
assignin('base', 'LongSide', defValue.LongSide);         % 2016/6/22 %
assignin('base', 'ShortSide', defValue.ShortSide);       % 2016/6/22 %
assignin('base', 'WheelBase', defValue.WheelBase);       % 2016/7/13 %
assignin('base', 'WheelR', defValue.WheelR);             % 2016/7/13 %
assignin('base', 'LongR', defValue.LongR);               % 2016/7/13 %
assignin('base', 'ShortR', defValue.ShortR);             % 2016/7/13 %
assignin('base', 'hok_t0', defValue.hok_t0);             % 2016/7/29 %
assignin('base', 'hok_vfactor', defValue.hok_vfactor);   % 2016/7/29 %

tmphok_v1 = (pi*defValue.WheelBase/defValue.hok_vfactor+defValue.LongSide+defValue.ShortSide-2*defValue.WheelBase) ...
    /(0.5*defValue.CircleT-2*(1-defValue.hok_vfactor)*defValue.hok_t0);  % `ix
tmphok_v2 = tmphok_v1*defValue.hok_vfactor;  % `R[i[񎞉E֑x
tmphok_t1 = 0.5*pi*defValue.WheelBase/tmphok_v2;  % `R[i[񎞊
tmphok_t2 = (defValue.LongSide-defValue.WheelBase-(tmphok_v1+tmphok_v2)*defValue.hok_t0)/tmphok_v1;  % LongSidei
tmphok_t3 = (defValue.ShortSide-defValue.WheelBase-(tmphok_v1+tmphok_v2)*defValue.hok_t0)/tmphok_v1;  % ShortSidei
assignin('base','hok_v1',tmphok_v1);
assignin('base','hok_v2',tmphok_v2);
assignin('base','hok_t1',tmphok_t1);
assignin('base','hok_t2',tmphok_t2);
assignin('base','hok_t3',tmphok_t3);

tmpzengo_v=defValue.LongSide/(defValue.CircleT/2-defValue.hok_t0);
assignin('base','zengo_v',tmpzengo_v);
%ȉ̓Xs[J[pp[^
assignin('base', 'SPK_VOL', 100);
assignin('base', 'SPK_FREQ_CP', 2794);
assignin('base', 'SPK_FREQ_RB', 1245);
